(ns
 youyesyet.routes.auto
 "JSON routes for Youyesyet auto-generated by [Application Description Language framework](https://github.com/simon-brooke/adl) at 20180610T194402.765Z"
 (:require
  [noir.response :as nresponse]
  [noir.util.route :as route]
  [compojure.core :refer [defroutes GET POST]]
  [ring.util.http-response :as response]
  [clojure.java.io :as io]
  [hugsql.core :as hugsql]
  [youyesyet.routes.manual :as m]))

(defn
 raw-resolve-template
 [n]
 (if
  (.exists (io/as-file (str "resources/templates/" n)))
  n
  (str "auto/n")))

(def resolve-template (memoise raw-resolve-template))

(defn
 list-electors-Electors
 [r]
 (layout/render
  (resolve-template "list-electors-Electors.html")
  {:title "Elector"}))

(defn
 form-electors-Elector
 [r]
 (layout/render
  (resolve-template "form-electors-Elector.html")
  {:title "Elector"}))

(defn
 list-genders-Genders
 [r]
 (layout/render
  (resolve-template "list-genders-Genders.html")
  {:title "Gender"}))

(defn
 form-genders-Gender
 [r]
 (layout/render
  (resolve-template "form-genders-Gender.html")
  {:title "Gender"}))

(defn
 list-dwellings-Dwellings
 [r]
 (layout/render
  (resolve-template "list-dwellings-Dwellings.html")
  {:title "Dwelling"}))

(defn
 form-dwellings-Dwelling
 [r]
 (layout/render
  (resolve-template "form-dwellings-Dwelling.html")
  {:title "Dwelling"}))

(defn
 list-addresses-Addresses
 [r]
 (layout/render
  (resolve-template "list-addresses-Addresses.html")
  {:title "Address"}))

(defn
 form-addresses-Address
 [r]
 (layout/render
  (resolve-template "form-addresses-Address.html")
  {:title "Address"}))

(defn
 list-visits-Visits
 [r]
 (layout/render
  (resolve-template "list-visits-Visits.html")
  {:title "Visit"}))

(defn
 form-visits-Visit
 [r]
 (layout/render
  (resolve-template "form-visits-Visit.html")
  {:title "Visit"}))

(defn
 list-authorities-Authorities
 [r]
 (layout/render
  (resolve-template "list-authorities-Authorities.html")
  {:title "Authority"}))

(defn
 form-authorities-Authority
 [r]
 (layout/render
  (resolve-template "form-authorities-Authority.html")
  {:title "Authority"}))

(defn
 list-issues-Issues
 [r]
 (layout/render
  (resolve-template "list-issues-Issues.html")
  {:title "Issue"}))

(defn
 form-issues-Issue
 [r]
 (layout/render
  (resolve-template "form-issues-Issue.html")
  {:title "Issue"}))

(defn
 list-intentions-Intentions
 [r]
 (layout/render
  (resolve-template "list-intentions-Intentions.html")
  {:title "Intention"}))

(defn
 form-intentions-Intention
 [r]
 (layout/render
  (resolve-template "form-intentions-Intention.html")
  {:title "Intention"}))

(defn
 list-canvassers-Canvassers
 [r]
 (layout/render
  (resolve-template "list-canvassers-Canvassers.html")
  {:title "Canvasser"}))

(defn
 form-canvassers-Canvasser
 [r]
 (layout/render
  (resolve-template "form-canvassers-Canvasser.html")
  {:title "Canvasser"}))

(defn
 list-followuprequests-Followuprequests
 [r]
 (layout/render
  (resolve-template "list-followuprequests-Followuprequests.html")
  {:title "Followuprequest"}))

(defn
 form-followuprequests-Followuprequest
 [r]
 (layout/render
  (resolve-template "form-followuprequests-Followuprequest.html")
  {:title "Followuprequest"}))

(defn
 list-roles-Roles
 [r]
 (layout/render
  (resolve-template "list-roles-Roles.html")
  {:title "Role"}))

(defn
 form-roles-Role
 [r]
 (layout/render
  (resolve-template "form-roles-Role.html")
  {:title "Role"}))

(defn
 list-teams-Teams
 [r]
 (layout/render
  (resolve-template "list-teams-Teams.html")
  {:title "Team"}))

(defn
 form-teams-Team
 [r]
 (layout/render
  (resolve-template "form-teams-Team.html")
  {:title "Team"}))

(defn
 list-districts-Districts
 [r]
 (layout/render
  (resolve-template "list-districts-Districts.html")
  {:title "District"}))

(defn
 form-districts-District
 [r]
 (layout/render
  (resolve-template "form-districts-District.html")
  {:title "District"}))

(defn
 list-followupactions-Followupactions
 [r]
 (layout/render
  (resolve-template "list-followupactions-Followupactions.html")
  {:title "Followupaction"}))

(defn
 form-followupactions-Followupaction
 [r]
 (layout/render
  (resolve-template "form-followupactions-Followupaction.html")
  {:title "Followupaction"}))

(defn
 list-options-Options
 [r]
 (layout/render
  (resolve-template "list-options-Options.html")
  {:title "Option"}))

(defn
 form-options-Option
 [r]
 (layout/render
  (resolve-template "form-options-Option.html")
  {:title "Option"}))

(defn
 list-followupmethods-Followupmethods
 [r]
 (layout/render
  (resolve-template "list-followupmethods-Followupmethods.html")
  {:title "Followupmethod"}))

(defn
 form-followupmethods-Followupmethod
 [r]
 (layout/render
  (resolve-template "form-followupmethods-Followupmethod.html")
  {:title "Followupmethod"}))

(defn
 raw-resolve-handler
 "Prefer the manually-written version of the handler with name `n`, if it exists, to the automatically generated one"
 [n]
 (let
  [s (symbol (str "m." n))]
  (if (bound? s) (eval s) (eval (symbol n)))))

(def resolve-handler (memoize raw-resolve-handler))

(defroutes
 auto-selmer-routes
 (GET
  "/form-addresses-Address"
  request
  (route/restricted
   (apply (resolve-handler "form-addresses-Address") (list request))))
 (POST
  "/form-addresses-Address"
  request
  (route/restricted
   (apply (resolve-handler "form-addresses-Address") (list request))))
 (GET
  "/form-authorities-Authority"
  request
  (route/restricted
   (apply
    (resolve-handler "form-authorities-Authority")
    (list request))))
 (POST
  "/form-authorities-Authority"
  request
  (route/restricted
   (apply
    (resolve-handler "form-authorities-Authority")
    (list request))))
 (GET
  "/form-canvassers-Canvasser"
  request
  (route/restricted
   (apply
    (resolve-handler "form-canvassers-Canvasser")
    (list request))))
 (POST
  "/form-canvassers-Canvasser"
  request
  (route/restricted
   (apply
    (resolve-handler "form-canvassers-Canvasser")
    (list request))))
 (GET
  "/form-districts-District"
  request
  (route/restricted
   (apply (resolve-handler "form-districts-District") (list request))))
 (POST
  "/form-districts-District"
  request
  (route/restricted
   (apply (resolve-handler "form-districts-District") (list request))))
 (GET
  "/form-dwellings-Dwelling"
  request
  (route/restricted
   (apply (resolve-handler "form-dwellings-Dwelling") (list request))))
 (POST
  "/form-dwellings-Dwelling"
  request
  (route/restricted
   (apply (resolve-handler "form-dwellings-Dwelling") (list request))))
 (GET
  "/form-electors-Elector"
  request
  (route/restricted
   (apply (resolve-handler "form-electors-Elector") (list request))))
 (POST
  "/form-electors-Elector"
  request
  (route/restricted
   (apply (resolve-handler "form-electors-Elector") (list request))))
 (GET
  "/form-followupactions-Followupaction"
  request
  (route/restricted
   (apply
    (resolve-handler "form-followupactions-Followupaction")
    (list request))))
 (POST
  "/form-followupactions-Followupaction"
  request
  (route/restricted
   (apply
    (resolve-handler "form-followupactions-Followupaction")
    (list request))))
 (GET
  "/form-followupmethods-Followupmethod"
  request
  (route/restricted
   (apply
    (resolve-handler "form-followupmethods-Followupmethod")
    (list request))))
 (POST
  "/form-followupmethods-Followupmethod"
  request
  (route/restricted
   (apply
    (resolve-handler "form-followupmethods-Followupmethod")
    (list request))))
 (GET
  "/form-followuprequests-Followuprequest"
  request
  (route/restricted
   (apply
    (resolve-handler "form-followuprequests-Followuprequest")
    (list request))))
 (POST
  "/form-followuprequests-Followuprequest"
  request
  (route/restricted
   (apply
    (resolve-handler "form-followuprequests-Followuprequest")
    (list request))))
 (GET
  "/form-genders-Gender"
  request
  (route/restricted
   (apply (resolve-handler "form-genders-Gender") (list request))))
 (POST
  "/form-genders-Gender"
  request
  (route/restricted
   (apply (resolve-handler "form-genders-Gender") (list request))))
 (GET
  "/form-intentions-Intention"
  request
  (route/restricted
   (apply
    (resolve-handler "form-intentions-Intention")
    (list request))))
 (POST
  "/form-intentions-Intention"
  request
  (route/restricted
   (apply
    (resolve-handler "form-intentions-Intention")
    (list request))))
 (GET
  "/form-issues-Issue"
  request
  (route/restricted
   (apply (resolve-handler "form-issues-Issue") (list request))))
 (POST
  "/form-issues-Issue"
  request
  (route/restricted
   (apply (resolve-handler "form-issues-Issue") (list request))))
 (GET
  "/form-options-Option"
  request
  (route/restricted
   (apply (resolve-handler "form-options-Option") (list request))))
 (POST
  "/form-options-Option"
  request
  (route/restricted
   (apply (resolve-handler "form-options-Option") (list request))))
 (GET
  "/form-roles-Role"
  request
  (route/restricted
   (apply (resolve-handler "form-roles-Role") (list request))))
 (POST
  "/form-roles-Role"
  request
  (route/restricted
   (apply (resolve-handler "form-roles-Role") (list request))))
 (GET
  "/form-teams-Team"
  request
  (route/restricted
   (apply (resolve-handler "form-teams-Team") (list request))))
 (POST
  "/form-teams-Team"
  request
  (route/restricted
   (apply (resolve-handler "form-teams-Team") (list request))))
 (GET
  "/form-visits-Visit"
  request
  (route/restricted
   (apply (resolve-handler "form-visits-Visit") (list request))))
 (POST
  "/form-visits-Visit"
  request
  (route/restricted
   (apply (resolve-handler "form-visits-Visit") (list request))))
 (GET
  "/list-addresses-Addresses"
  request
  (route/restricted
   (apply
    (resolve-handler "list-addresses-Addresses")
    (list request))))
 (POST
  "/list-addresses-Addresses"
  request
  (route/restricted
   (apply
    (resolve-handler "list-addresses-Addresses")
    (list request))))
 (GET
  "/list-authorities-Authorities"
  request
  (route/restricted
   (apply
    (resolve-handler "list-authorities-Authorities")
    (list request))))
 (POST
  "/list-authorities-Authorities"
  request
  (route/restricted
   (apply
    (resolve-handler "list-authorities-Authorities")
    (list request))))
 (GET
  "/list-canvassers-Canvassers"
  request
  (route/restricted
   (apply
    (resolve-handler "list-canvassers-Canvassers")
    (list request))))
 (POST
  "/list-canvassers-Canvassers"
  request
  (route/restricted
   (apply
    (resolve-handler "list-canvassers-Canvassers")
    (list request))))
 (GET
  "/list-districts-Districts"
  request
  (route/restricted
   (apply
    (resolve-handler "list-districts-Districts")
    (list request))))
 (POST
  "/list-districts-Districts"
  request
  (route/restricted
   (apply
    (resolve-handler "list-districts-Districts")
    (list request))))
 (GET
  "/list-dwellings-Dwellings"
  request
  (route/restricted
   (apply
    (resolve-handler "list-dwellings-Dwellings")
    (list request))))
 (POST
  "/list-dwellings-Dwellings"
  request
  (route/restricted
   (apply
    (resolve-handler "list-dwellings-Dwellings")
    (list request))))
 (GET
  "/list-electors-Electors"
  request
  (route/restricted
   (apply (resolve-handler "list-electors-Electors") (list request))))
 (POST
  "/list-electors-Electors"
  request
  (route/restricted
   (apply (resolve-handler "list-electors-Electors") (list request))))
 (GET
  "/list-followupactions-Followupactions"
  request
  (route/restricted
   (apply
    (resolve-handler "list-followupactions-Followupactions")
    (list request))))
 (POST
  "/list-followupactions-Followupactions"
  request
  (route/restricted
   (apply
    (resolve-handler "list-followupactions-Followupactions")
    (list request))))
 (GET
  "/list-followupmethods-Followupmethods"
  request
  (route/restricted
   (apply
    (resolve-handler "list-followupmethods-Followupmethods")
    (list request))))
 (POST
  "/list-followupmethods-Followupmethods"
  request
  (route/restricted
   (apply
    (resolve-handler "list-followupmethods-Followupmethods")
    (list request))))
 (GET
  "/list-followuprequests-Followuprequests"
  request
  (route/restricted
   (apply
    (resolve-handler "list-followuprequests-Followuprequests")
    (list request))))
 (POST
  "/list-followuprequests-Followuprequests"
  request
  (route/restricted
   (apply
    (resolve-handler "list-followuprequests-Followuprequests")
    (list request))))
 (GET
  "/list-genders-Genders"
  request
  (route/restricted
   (apply (resolve-handler "list-genders-Genders") (list request))))
 (POST
  "/list-genders-Genders"
  request
  (route/restricted
   (apply (resolve-handler "list-genders-Genders") (list request))))
 (GET
  "/list-intentions-Intentions"
  request
  (route/restricted
   (apply
    (resolve-handler "list-intentions-Intentions")
    (list request))))
 (POST
  "/list-intentions-Intentions"
  request
  (route/restricted
   (apply
    (resolve-handler "list-intentions-Intentions")
    (list request))))
 (GET
  "/list-issues-Issues"
  request
  (route/restricted
   (apply (resolve-handler "list-issues-Issues") (list request))))
 (POST
  "/list-issues-Issues"
  request
  (route/restricted
   (apply (resolve-handler "list-issues-Issues") (list request))))
 (GET
  "/list-options-Options"
  request
  (route/restricted
   (apply (resolve-handler "list-options-Options") (list request))))
 (POST
  "/list-options-Options"
  request
  (route/restricted
   (apply (resolve-handler "list-options-Options") (list request))))
 (GET
  "/list-roles-Roles"
  request
  (route/restricted
   (apply (resolve-handler "list-roles-Roles") (list request))))
 (POST
  "/list-roles-Roles"
  request
  (route/restricted
   (apply (resolve-handler "list-roles-Roles") (list request))))
 (GET
  "/list-teams-Teams"
  request
  (route/restricted
   (apply (resolve-handler "list-teams-Teams") (list request))))
 (POST
  "/list-teams-Teams"
  request
  (route/restricted
   (apply (resolve-handler "list-teams-Teams") (list request))))
 (GET
  "/list-visits-Visits"
  request
  (route/restricted
   (apply (resolve-handler "list-visits-Visits") (list request))))
 (POST
  "/list-visits-Visits"
  request
  (route/restricted
   (apply (resolve-handler "list-visits-Visits") (list request)))))

